<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.12">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../favicon.png">
  <title>SVG visualization | Chi documentation</title>
  <link rel="stylesheet" href="../assets/asciidoctor-escet-chi.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../assets/styles/asciidoctor-highlightjs-escet.min.css"> <!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../assets/asciidoctor-escet-chi.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="..">Chi website</a></p>
    <div id="toctitle">
     Chi documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../documentation.html">Home</a></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/index.html">Chi Tutorial</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/introduction.html">Introduction</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/introduction.html#chi-in-a-nutshell">Chi in a nutshell</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/introduction.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html">Data types</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html#elementary-types">Elementary types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#booleans">Booleans</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#enumerations">Enumerations</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#numbers">Numbers</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#strings">Strings</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html#tuple-types">Tuple types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#notation">Notation</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#operator">Operator</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html#container-types">Container types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#lists">Lists</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#initialization">Initialization</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#sets">Sets</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#dictionaries">Dictionaries</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#custom-types">Custom types</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/statements.html">Statements</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-assignment-statement">The assignment statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-if-statement">The <code>if</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-while-statement">The <code>while</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-for-statement">The <code>for</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#notes">Notes</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/functions.html">Functions</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/functions.html#sorted-lists">Sorted lists</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/functions.html#sort">Sort</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/functions.html#insert">Insert</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/input-output.html">Input and output</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#the-read-function">The <code>read</code> function</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#reading-from-a-file">Reading from a file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#advanced-reading-from-a-file">Advanced reading from a file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#the-write-statement">The <code>write</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#writing-to-a-file">Writing to a file</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/stochastic-behavior.html">Modeling stochastic behavior</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/stochastic-behavior.html#distributions">Distributions</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#constant-distributions">Constant distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#discrete-distributions">Discrete distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#continuous-distributions">Continuous distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#references">References</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#simulating-stochastic-behavior">Simulating stochastic behavior</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/processes.html">Processes</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/processes.html#a-single-process">A single process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/processes.html#a-process-in-a-process">A process in a process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/processes.html#many-processes">Many processes</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/channels.html">Channels</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#a-channel">A channel</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#synchronization-channels">Synchronization channels</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#two-channels">Two channels</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#more-senders-or-receivers">More senders or receivers</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#notes">Notes</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/buffers.html">Buffers</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-one-place-buffer">A one-place buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-single-process-buffer">A single process buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#an-infinite-buffer">An infinite buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-token-buffer">A token buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-priority-buffer">A priority buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/servers.html">Servers with time</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/servers.html#the-clock">The clock</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/servers.html#adding-time">Adding time</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#a-deterministic-system">A deterministic system</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#a-stochastic-system">A stochastic system</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/servers.html#two-servers">Two servers</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#serial-system">Serial system</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#parallel-systems">Parallel systems</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/servers.html#assembly">Assembly</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/servers.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/conveyors.html">Conveyors</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#timers">Timers</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#a-conveyor">A conveyor</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#a-priority-conveyor">A priority conveyor</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/experiments.html">Simulations and experiments</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/experiments.html#simulating-finite-systems">Simulating finite systems</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/experiments.html#simulating-infinite-systems">Simulating infinite systems</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/experiments.html#simulating-several-scenarios">Simulating several scenarios</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/svg-visualization.html">SVG visualization</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-visualization.html#the-svg-file-format">The SVG file format</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-visualization.html#visualization">Visualization</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/svg-example.html">SVG visualization example</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#buffer-visualization">Buffer visualization</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#vertical-coordinates-trickery">Vertical coordinates trickery</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#server-process">Server process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#visualizing-the-server">Visualizing the server</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#copying-svg-elements">Copying SVG elements</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#moving-svg-elements">Moving SVG elements</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="index.html">Chi Reference Manual</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="globals.html">Global definitions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#enumeration-definitions">Enumeration definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#type-definitions">Type definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#constant-definitions">Constant definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#process-definitions">Process definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#model-definitions">Model definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#function-definitions">Function definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#experiment-definitions">Experiment definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#formal-parameters">Formal parameters</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html">Statements</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#local-variables">Local variables</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#assignment-statement">Assignment statement</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#iterative-statements">Iterative statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#while-loop-statement">While loop statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#for-loop-statement">For loop statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#break-statement">Break statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#continue-statement">Continue statement</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#choice-statement">Choice statement</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#sub-process-statements">Sub-process statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#run-and-start-statements">Run and start statements</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#finish-statement">Finish statement</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#communication-statements">Communication statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#send-statement">Send statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#receive-statement">Receive statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#select-statement">Select statement</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#other-statements">Other statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#delay-statement">Delay statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#write-statement">Write statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#close-statement">Close statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#return-statement">Return statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#exit-statement">Exit statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#pass-statement">Pass statement</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="expressions.html">Expressions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#typed-expressions">Typed expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#enumeration-value">Enumeration value</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#boolean-expressions">Boolean expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#integer-expressions">Integer expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#real-number-expressions">Real number expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#string-expressions">String expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#list-expressions">List expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#set-expressions">Set expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#dictionary-expressions">Dictionary expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#tuple-expression">Tuple expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#file-handle-expressions">File handle expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#read-expression">Read expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#timer-expressions">Timer expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#channel-expressions">Channel expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#distribution-expressions">Distribution expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#process-expressions">Process expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#instance-expressions">Instance expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#matrix-expression">Matrix expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#cast-expressions">Cast expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#function-call-expressions">Function call expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#operator-priorities">Operator priorities</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="stdlib.html">Standard library functions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#integer-functions">Integer functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#real-number-functions">Real number functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#string-functions">String functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#list-functions">List functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#set-functions">Set functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#dictionary-functions">Dictionary functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#timer-functions">Timer functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#file-functions">File functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#process-instance-functions">Process instance functions</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="distributions.html">Distributions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="distributions.html#constant-distributions">Constant distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="distributions.html#discrete-distributions">Discrete distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="distributions.html#continuous-distributions">Continuous distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="distributions.html#references">References</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="types.html">Types</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="types.html#elementary-types">Elementary types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#boolean-type">Boolean type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#integer-type">Integer type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#real-type">Real type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#string-type">String type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#file-type">File type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#instance-type">Instance type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#timer-type">Timer type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#matrix-type">Matrix type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#void-type">Void type</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="types.html#container-types">Container types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#list-type">List type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#set-type">Set type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#dictionary-type">Dictionary type</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#tuple-type">Tuple type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#channel-type">Channel type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#distribution-type">Distribution type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#function-type">Function type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#process-type">Process type</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="lexicals.html">Lexical syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexicals.html#whitespace">Whitespace</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexicals.html#comment">Comment</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexicals.html#names">Names</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="migration.html">Model migration</a></li>
       <li class="toc-cur-page toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">SVG visualization</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#svg-interface">SVG interface</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#visualization-modification-commands">Visualization modification commands</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/index.html">Chi Tool Manual</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/operation.html">Software operation</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/operation.html#compile-and-simulate">Compile and simulate</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#quick-simulate">Quick simulate</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#compile-only">Compile only</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#simulate-a-compiled-model">Simulate a compiled model</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#terminating-a-simulation">Terminating a simulation</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/command-line.html">Command line options</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#simulator-options">Simulator options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#general-application-options">General application options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#compiler-options">Compiler options</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../release-notes.html">Chi release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-4-0-2024-06-30">Version 4.0 (2024-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../documentation.html">Chi documentation</a> &gt; <a class="breadcrumb" href="index.html">Chi Reference Manual</a> &gt; <span class="breadcrumb">SVG visualization</span>
   </div>
   <h2 id="svg-visualization"><a class="anchor" href="#"></a>SVG visualization</h2>
   <div class="paragraph">
    <p>The Chi simulator has the possibility to display an SVG file during the simulation. The model can modify the displayed image depending on the state of the simulated system, thus visualizing the system.</p>
   </div>
   <div class="paragraph">
    <p>Such a visualization is useful for getting a quick global verification, as well as explaining the purpose of the model to people that do not know the detailed ins and outs of the problem being solved.</p>
   </div>
   <div class="paragraph">
    <p>Below are the technical details of the SVG visualization. The tutorial has a <a href="../tutorial/svg-visualization.html">more gentle introduction</a> into the subject.</p>
   </div>
   <div class="sect3">
    <h3 id="svg-interface"><a class="anchor" href="#svg-interface"></a>SVG interface</h3>
    <div class="paragraph">
     <p>The SVG visualization itself is controlled by the simulator. Normally, it is updated just before a time step is performed. The simulation can however force an update with the <code>redraw</code> command (see below for details).</p>
    </div>
    <div class="paragraph">
     <p>The simulation accesses the SVG visualization by opening a file for writing with a name like <code>SVG:xyz.svg</code>. The <code>SVG:</code> prefix redirects the request to the SVG visualizer, the <code>xyz.svg</code> suffix is the name of the SVG file to display. The file should be available at the file system.</p>
    </div>
    <div class="paragraph">
     <p>Different Chi processes may open the same file at the same time. The SVG visualizer can only display one SVG file at a time, it is not allowed for processes to open different <code>.svg</code> files.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="visualization-modification-commands"><a class="anchor" href="#visualization-modification-commands"></a>Visualization modification commands</h3>
    <div class="paragraph">
     <p>After opening the file, the content of the SVG file can be changed by modifying the nodes. This is done by writing lines with commands (one command at each line). Available commands are:</p>
    </div>
    <div class="ulist">
     <ul>
      <li><p><strong>Copy an element (recursively)</strong></p>
       <div class="paragraph">
        <p><code>copy [orig-id], [opt-prefix], [op-suffix]</code>, with <code>[orig-id]</code> the id-name of the element to copy, <code>[opt-prefix]</code> an optional prefix that is added to the <code>id</code> of all copied elements, and <code>[opt-suffix]</code> an optional suffix that is added to the <code>id</code> of all copied elements. Since the <code>id</code> of all elements must be unique, leaving both the prefix and the suffix empty gives an error about duplicate <code>id</code> labels.</p>
       </div>
       <div class="paragraph">
        <p>Note that the element (and its descendants) is only copied, but not moved. In other words, after copying it is fully obscured by the original element. The next step is normally an absolute move command or an attribute command to perform a relative translate transformation.</p>
       </div></li>
      <li><p><strong>Move an element to an absolute position</strong></p>
       <div class="paragraph">
        <p><code>absmove [id] ([xpos], [ypos])</code> with <code>[id]</code> the id-name of the element to move, <code>[xpos]</code> the horizontal position to move to, and <code>[ypos]</code> the vertical position to move to. This operation adds a translation to the <code>transform</code> attribute of the node such that the top-left corner of the bounding rectangle is moved to the provided position. It also takes the existing transformation into account, and in doing so, will fail if the transformation cannot be reversed.</p>
       </div>
       <div class="paragraph">
        <p>The origin of the coordinate system is at the top-left of the SVG visualization window, with positive X running to the right, and positive Y running down.</p>
       </div>
       <div class="paragraph">
        <p>Avoid using this operation repeatedly on the same element. Instead move it once to a base position, and perform relative translate transformations on a child element to move it to the desired position.</p>
       </div></li>
      <li><p><strong>Change an attribute of an element</strong></p>
       <div class="paragraph">
        <p><code>attr [id].[atrribute] = [value]</code> with <code>[id]</code> the id-name of the element, <code>[attribute]</code> the name of the attribute of the element to change, and <code>[value]</code> the new value of the attribute.</p>
       </div>
       <div class="paragraph">
        <p>A change overwrites any previous value of the attribute. Also, names of attributes and syntax of values are not checked.</p>
       </div></li>
      <li><p><strong>Change the text of an element</strong></p>
       <div class="paragraph">
        <p><code>text [id] = [value]</code> with <code>[id]</code> the id-name of the element, and <code>[value]</code> the new text.</p>
       </div></li>
      <li><p><strong>Force a redraw of the image</strong></p>
       <div class="paragraph">
        <p>Normally the program redraws the SVG image when it detects a change in time after making changes in the image by using one of the previous commands. With this command you can fake a change in time, thus allowing you to also display intermediate states.</p>
       </div>
       <div class="paragraph">
        <p>The command is mostly useful in experiments, where time never changes.</p>
       </div></li>
     </ul>
    </div>
   </div>
  </div>
  <script src="../assets/highlight.min.js"></script>
  <script src="../assets/languages/asciidoc.min.js"></script>
  <script src="../assets/languages/bash.min.js"></script>
  <script src="../assets/languages/bnf.min.js"></script>
  <script src="../assets/languages/c.min.js"></script>
  <script src="../assets/languages/chi.min.js"></script>
  <script src="../assets/languages/cif.min.js"></script>
  <script src="../assets/languages/console.min.js"></script>
  <script src="../assets/languages/css.min.js"></script>
  <script src="../assets/languages/dsm.min.js"></script>
  <script src="../assets/languages/java.min.js"></script>
  <script src="../assets/languages/javascript.min.js"></script>
  <script src="../assets/languages/markdown.min.js"></script>
  <script src="../assets/languages/mcrl2.min.js"></script>
  <script src="../assets/languages/none.min.js"></script>
  <script src="../assets/languages/properties.min.js"></script>
  <script src="../assets/languages/raildiagram.min.js"></script>
  <script src="../assets/languages/setext.min.js"></script>
  <script src="../assets/languages/shell.min.js"></script>
  <script src="../assets/languages/tooldef.min.js"></script>
  <script src="../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script> <!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>Chi documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v4.0</span><br> <a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>